import { ref, readonly } from 'vue';

var useState = initial => {
  var state = ref(initial);

  var dispatch = next => {
    var draft = typeof next === 'function' ? next(state.value) : next;
    state.value = draft;
  };

  return [readonly(state), dispatch];
};

export { useState };